package com.io.yutian.elementoriginlib.command;

import com.io.yutian.elementoriginlib.command.argument.ArgumentValue;
import org.bukkit.command.CommandSender;

import java.util.Map;

public class CommandContext {

    private String command;
    private String label;
    private CommandSender sender;
    private Map<String, ArgumentValue> argumentsValues;

    public CommandContext(String command, String label, CommandSender sender, Map<String, ArgumentValue> argumentsValues) {
        this.command = command;
        this.label = label;
        this.sender = sender;
        this.argumentsValues = argumentsValues;
    }

    public String getCommand() {
        return command;
    }

    public String getLabel() {
        return label;
    }

    public CommandSender getSender() {
        return sender;
    }

    public ArgumentValue getArgumentsValue(String key) {
        return argumentsValues.getOrDefault(key, new ArgumentValue(null));
    }

}
