package com.io.yutian.elementoriginlib.command.argument;

import com.io.yutian.elementoriginlib.command.Suggest;

public class Argument {

    private String name;

    private ArgumentType argumentsType;

    private Suggest suggest;

    private boolean optional = false;
    private Object defaultValue = null;

    public Argument(String name, ArgumentType argumentsType) {
        this.name = name;
        this.argumentsType = argumentsType;
    }

    public Argument optional(Object defaultValue) {
        optional = true;
        this.defaultValue = defaultValue;
        return this;
    }

    public String getName() {
        return name;
    }

    public ArgumentType getArgumentsType() {
        return argumentsType;
    }

    public boolean isOptional() {
        return optional;
    }

    public Object getDefaultValue() {
        return defaultValue;
    }

    public Argument suggest(Suggest suggest) {
        this.suggest = suggest;
        return this;
    }

    public Suggest getSuggest() {
        return suggest;
    }

    public static Argument argument(String name, ArgumentType type) {
        return new Argument(name, type);
    }

}
