package com.io.yutian.elementoriginlib.command.argument;

import com.io.yutian.elementoriginlib.util.StringUtil;

import java.util.UUID;

public class ArgumentTypes {

    public static final ArgumentType<String> STRING = new ArgumentType<>("string", (s) -> true, (s) -> s);

    public static final ArgumentType<Integer> INTEGER = new ArgumentType<>("integer", StringUtil::isInt, Integer::parseInt);

    public static final ArgumentType<Double> DOUBLE = new ArgumentType<>("double", StringUtil::isDouble, Double::parseDouble);

    public static final ArgumentType<UUID> UUID = new ArgumentType<>("uuid", StringUtil::isUUID, java.util.UUID::fromString);

    public static final ArgumentType<Boolean> BOOLEAN = new ArgumentType<>("boolean", StringUtil::isBoolean, Boolean::parseBoolean);

}