package com.io.yutian.elementoriginlib.gui.button;

import org.bukkit.Material;
import org.bukkit.inventory.ItemStack;

import java.util.function.Consumer;

public class ItemSlotButton extends Button {

    private Consumer<ItemStack> putItemFunction;
    private Consumer<ItemStack> pickItemFunction;

    private boolean canPut = true;

    public ItemSlotButton() {
        super(new ItemStack(Material.AIR));
    }

    public ItemSlotButton putItem(Consumer<ItemStack> putItemConsumer) {
        this.putItemFunction = putItemConsumer;
        return this;
    }

    public ItemSlotButton pickItem(Consumer<ItemStack> pickItemConsumer) {
        this.pickItemFunction = pickItemConsumer;
        return this;
    }

    public ItemSlotButton canPut(boolean can) {
        this.canPut = can;
        return this;
    }

    public boolean isCanPut() {
        return canPut;
    }

    public Consumer<ItemStack> getPickItemFunction() {
        return pickItemFunction;
    }

    public Consumer<ItemStack> getPutItemFunction() {
        return putItemFunction;
    }

}
