package com.io.yutian.elementoriginlib.item.stat;

import com.io.yutian.elementoriginlib.item.stat.list.IDStat;
import com.io.yutian.elementoriginlib.item.stat.type.StringStat;

import java.util.HashMap;
import java.util.Map;

public class ItemStats {

    private static Map<String, ItemStat<?>> itemStats = new HashMap<>();

    public static final StringStat ID = register(new IDStat());

    public static <I extends ItemStat> I register(I itemStat) {
        if (itemStats.containsKey(itemStat.getId())) {
            return itemStat;
        }
        itemStats.put(itemStat.getId(), itemStat);
        return itemStat;
    }

    public static void unregister(ItemStat itemStat) {
        itemStats.remove(itemStat.getId());
    }

    public static ItemStat getItemStat(String id) {
        return itemStats.get(id);
    }

}
