package com.io.yutian.elementoriginlib.item.stat.data;

import com.io.yutian.elementoriginlib.item.stat.Mergeable;
import com.io.yutian.elementoriginlib.item.stat.StatData;
import org.jetbrains.annotations.NotNull;

public class DoubleData implements StatData, Mergeable<DoubleData> {

    private double value;

    public DoubleData(double value) {
        this.value = value;
    }

    public double getValue() {
        return value;
    }

    public void setValue(double value) {
        this.value = value;
    }

    public void add(double d) {
        this.value += d;
    }

    @Override
    public void merge(DoubleData var1) {
        this.value += var1.getValue();
    }

    @NotNull
    @Override
    public DoubleData cloneData() {
        return new DoubleData(getValue());
    }

    @Override
    public boolean isEmpty() {
        return value == 0.0d;
    }

    @Override
    public String toString() {
        return String.valueOf(value);
    }

    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        DoubleData that = (DoubleData) o;
        return Double.compare(that.value, value) == 0;
    }


}
