package com.io.yutian.elementoriginlib.item.stat.data;

import com.io.yutian.elementoriginlib.item.stat.Mergeable;
import com.io.yutian.elementoriginlib.item.stat.StatData;
import org.jetbrains.annotations.NotNull;

import java.util.List;

public class StringListData implements StatData, Mergeable<StringListData> {

    private List<String> list;

    public StringListData(List<String> list) {
        this.list = list;
    }

    public List<String> getList() {
        return list;
    }

    public void add(String str) {
        this.list.add(str);
    }

    @Override
    public void merge(StringListData var1) {
        this.list.addAll(var1.getList());
    }

    @NotNull
    @Override
    public StringListData cloneData() {
        return new StringListData(list);
    }

    @Override
    public boolean isEmpty() {
        return list.isEmpty();
    }

}
