package com.io.yutian.elementoriginlib.item.stat.type;

import com.io.yutian.elementoriginlib.item.OriginItemStackBuilder;
import com.io.yutian.elementoriginlib.item.stat.ItemStat;
import com.io.yutian.elementoriginlib.item.stat.data.BooleanData;
import com.io.yutian.elementoriginlib.nbt.NBTByte;
import com.io.yutian.elementoriginlib.nbt.NBTItem;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;

public abstract class BooleanStat extends ItemStat<BooleanData> {

    public BooleanStat(@NotNull String id, @NotNull String path) {
        super(id, path);
    }

    @Override
    public void whenApplied(@NotNull OriginItemStackBuilder itemStackBuilder, @NotNull BooleanData statData) {
        NBTItem nbtItem = itemStackBuilder.getNBTItem();
        nbtItem.editTag(nbtCompound -> nbtCompound.putByte(getNBTPath(), (byte) (statData.getValue() ? 1 : 0)));
    }

    @Nullable
    @Override
    public BooleanData getLoadedNBT(@NotNull NBTItem nbtItem) {
        return new BooleanData(((NBTByte) nbtItem.get(getNBTPath())).getByte() == 1);
    }

}
