package com.io.yutian.elementoriginlib.item.stat.type;

import com.io.yutian.elementoriginlib.item.OriginItemStackBuilder;
import com.io.yutian.elementoriginlib.item.stat.ItemStat;
import com.io.yutian.elementoriginlib.item.stat.data.DoubleData;
import com.io.yutian.elementoriginlib.nbt.NBTDouble;
import com.io.yutian.elementoriginlib.nbt.NBTItem;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;

public abstract class DoubleStat extends ItemStat<DoubleData> {

    public DoubleStat(@NotNull String id, @NotNull String path) {
        super(id, path);
    }

    @Override
    public void whenApplied(@NotNull OriginItemStackBuilder itemStackBuilder, @NotNull DoubleData statData) {
        NBTItem nbtItem = itemStackBuilder.getNBTItem();
        nbtItem.editTag(nbtCompound -> nbtCompound.putDouble(getNBTPath(), statData.getValue()));
    }

    @Nullable
    @Override
    public DoubleData getLoadedNBT(@NotNull NBTItem nbtItem) {
        return new DoubleData(((NBTDouble) nbtItem.get(getNBTPath())).getDouble());
    }

}
