package com.io.yutian.elementoriginlib.item.stat.type;

import com.io.yutian.elementoriginlib.item.OriginItemStackBuilder;
import com.io.yutian.elementoriginlib.item.stat.ItemStat;
import com.io.yutian.elementoriginlib.item.stat.data.IntData;
import com.io.yutian.elementoriginlib.nbt.NBTInt;
import com.io.yutian.elementoriginlib.nbt.NBTItem;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;

public abstract class IntStat extends ItemStat<IntData> {

    public IntStat(@NotNull String id, @NotNull String path) {
        super(id, path);
    }

    @Override
    public void whenApplied(@NotNull OriginItemStackBuilder itemStackBuilder, @NotNull IntData statData) {
        NBTItem nbtItem = itemStackBuilder.getNBTItem();
        nbtItem.editTag(nbtCompound -> nbtCompound.putInt(getNBTPath(), statData.getInt()));
    }

    @Nullable
    @Override
    public IntData getLoadedNBT(@NotNull NBTItem nbtItem) {
        return new IntData(((NBTInt)nbtItem.get(getNBTPath())).getInt());
    }

}
