package com.io.yutian.elementoriginlib.item.stat.type;

import com.io.yutian.elementoriginlib.item.OriginItemStackBuilder;
import com.io.yutian.elementoriginlib.item.stat.ItemStat;
import com.io.yutian.elementoriginlib.item.stat.data.StringData;
import com.io.yutian.elementoriginlib.nbt.NBTItem;
import com.io.yutian.elementoriginlib.nbt.NBTString;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;

public abstract class StringStat extends ItemStat<StringData> {

    public StringStat(@NotNull String id, @NotNull String path) {
        super(id, path);
    }

    @Override
    public void whenApplied(@NotNull OriginItemStackBuilder itemStackBuilder, @NotNull StringData statData) {
        NBTItem nbtItem = itemStackBuilder.getNBTItem();
        nbtItem.editTag(nbtCompound -> nbtCompound.putString(getNBTPath(), statData.getString()));
    }


    @Nullable
    @Override
    public StringData getLoadedNBT(@NotNull NBTItem nbtItem) {
        return new StringData(((NBTString) nbtItem.get(getNBTPath())).getString());
    }

}
