package com.io.yutian.elementoriginlib.item.stat.type;

import com.io.yutian.elementoriginlib.item.OriginItemStackBuilder;
import com.io.yutian.elementoriginlib.item.stat.ItemStat;
import com.io.yutian.elementoriginlib.item.stat.data.UUIDData;
import com.io.yutian.elementoriginlib.nbt.NBTItem;
import com.io.yutian.elementoriginlib.nbt.NBTString;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;

import java.util.UUID;

public abstract class UUIDStat extends ItemStat<UUIDData> {

    public UUIDStat(@NotNull String id, @NotNull String path) {
        super(id, path);
    }

    @Override
    public void whenApplied(@NotNull OriginItemStackBuilder itemStackBuilder, @NotNull UUIDData statData) {
        NBTItem nbtItem = itemStackBuilder.getNBTItem();
        nbtItem.editTag(nbtCompound -> nbtCompound.putString(getNBTPath(), statData.getUUID().toString()));
    }

    @Nullable
    @Override
    public UUIDData getLoadedNBT(@NotNull NBTItem nbtItem) {
        return new UUIDData(UUID.fromString(((NBTString) nbtItem.get(getNBTPath())).getString()));
    }

}
