package com.io.yutian.elementoriginlib.nbt;

import org.jetbrains.annotations.Nullable;

public class NBTHelper {

    @Nullable
    public static INBT convert(Object object) {
        if (object instanceof Byte) {
            return new NBTByte((byte) object);
        } else if (object instanceof Short) {
            return new NBTShort((short) object);
        } else if (object instanceof Integer) {
            return new NBTInt((int) object);
        } else if (object instanceof Long) {
            return new NBTLong((long) object);
        } else if (object instanceof Float) {
            return new NBTFloat((float) object);
        } else if (object instanceof Double) {
            return new NBTDouble((double) object);
        } else if (object instanceof byte[]) {
            return new NBTByteArray((byte[]) object);
        } else if (object instanceof String) {
            return new NBTString((String) object);
        } else if (object instanceof int[]) {
            return new NBTIntArray((int[]) object);
        } else if (object instanceof long[]) {
            return new NBTLongArray((long[]) object);
        } else if (object instanceof Boolean) {
            return new NBTByte((byte) ((boolean)object ? 1 : 0));
        }
        return null;
    }

    public static Object convertNMSNBT(INBT nbt) {
        return INBT.asNMS(nbt);
    }

}
