package com.io.yutian.elementoriginlib.nbt;

public class NBTLong extends NBTNumber {

    public static byte TYPE_ID = 4;

    private long value;

    public NBTLong(long value) {
        this.value = value;
    }

    public NBTLong() {
    }

    @Override
    public Object getValue() {
        return this.value;
    }

    @Override
    public byte getTypeId() {
        return TYPE_ID;
    }

    @Override
    public long getLong() {
        return this.value;
    }

    @Override
    public int getInt() {
        return (int)(this.value & 0x7fffffffffffffffL);
    }

    @Override
    public short getShort() {
        return (short)(this.value & 0xFFFF);
    }

    @Override
    public byte getByte() {
        return (byte)(this.value & 0xFF);
    }

    @Override
    public double getDouble() {
        return this.value;
    }

    @Override
    public float getFloat() {
        return (float) this.value;
    }

    @Override
    public String toString() {
        return "NBTLong{" +
                "value=" + value +
                '}';
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;

        NBTLong nbtLong = (NBTLong) o;
        return value == nbtLong.value;
    }

    @Override
    public int hashCode() {
        return Long.hashCode(value);
    }
}
