package com.io.yutian.elementoriginlib.nbt;

public class NBTShort extends NBTNumber {

    public static byte TYPE_ID = 2;

    private short value;

    public NBTShort(short value) {
        this.value = value;
    }

    public NBTShort() {
    }

    @Override
    public Object getValue() {
        return this.value;
    }

    @Override
    public byte getTypeId() {
        return TYPE_ID;
    }

    @Override
    public long getLong() {
        return this.value;
    }

    @Override
    public int getInt() {
        return this.value;
    }

    @Override
    public short getShort() {
        return this.value;
    }

    @Override
    public byte getByte() {
        return (byte)(this.value & 0xFF);
    }

    @Override
    public double getDouble() {
        return this.value;
    }

    @Override
    public float getFloat() {
        return this.value;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;

        NBTShort nbtShort = (NBTShort) o;
        return value == nbtShort.value;
    }

    @Override
    public int hashCode() {
        return value;
    }

    @Override
    public String toString() {
        return "NBTShort{" +
                "value=" + value +
                '}';
    }

}
