package com.io.yutian.elementoriginlib.sql.api.action;

import com.io.yutian.elementoriginlib.sql.api.SQLAction;
import org.jetbrains.annotations.NotNull;

import java.util.List;

@SuppressWarnings("UnusedReturnValue")
public interface SQLUpdateBatchAction extends SQLAction<List<Integer>> {

    /**
     * 添加一条批量执行的SQL语句
     *
     * @param sql SQL语句
     * @return {@link SQLUpdateBatchAction}
     */
    SQLUpdateBatchAction addBatch(@NotNull String sql);

    @Override
    default @NotNull String getSQLContent() {
        return getSQLContents().get(0);
    }

    @Override
    @NotNull List<String> getSQLContents();

}
