package com.io.yutian.elementoriginlib.sql.api.builder;

import com.io.yutian.elementoriginlib.sql.api.SQLAction;

import java.util.Arrays;
import java.util.List;

public interface InsertBuilder<T extends SQLAction<?>> {

    String getTableName();

    boolean isIgnore();

    InsertBuilder<T> setIgnore(boolean ignore);

    T setColumnNames(List<String> columnNames);

    default T setColumnNames(String... columnNames) {
        return setColumnNames(columnNames == null ? null : Arrays.asList(columnNames));
    }


}
