package com.io.yutian.elementoriginlib.sql.builder.impl;

import com.io.yutian.elementoriginlib.sql.api.SQLAction;
import com.io.yutian.elementoriginlib.sql.api.builder.ReplaceBuilder;
import com.io.yutian.elementoriginlib.sql.builder.AbstractSQLBuilder;
import com.io.yutian.elementoriginlib.sql.manager.SQLManagerImpl;
import org.jetbrains.annotations.NotNull;

import java.util.List;

public abstract class ReplaceBuilderImpl<T extends SQLAction<?>>
        extends AbstractSQLBuilder implements ReplaceBuilder<T> {

    protected final @NotNull String tableName;

    public ReplaceBuilderImpl(@NotNull SQLManagerImpl manager, @NotNull String tableName) {
        super(manager);
        this.tableName = tableName;
    }

    protected static String buildSQL(String tableName, List<String> columnNames) {
        return InsertBuilderImpl.buildSQL("REPLACE INTO", tableName, columnNames);
    }

    @Override
    public @NotNull String getTableName() {
        return tableName;
    }
}
