package com.io.yutian.elementoriginlib.util;

import com.io.yutian.elementoriginlib.ElementOriginLib;
import com.io.yutian.elementoriginlib.expiringmap.ExpirationPolicy;
import com.io.yutian.elementoriginlib.expiringmap.ExpiringMap;
import org.json.JSONObject;

import java.io.File;
import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.util.concurrent.TimeUnit;

public class LangUtil {

    private static ExpiringMap<String, String> expiringMap = ExpiringMap.builder().expiration(3, TimeUnit.MINUTES).expirationPolicy(ExpirationPolicy.CREATED).build();
    private static JSONObject jsonObject = new JSONObject();

    public static String getLang(String key) {
        if (expiringMap.containsKey(key)) {
            return expiringMap.get(key);
        }
        String value = jsonObject.getString(key);
        expiringMap.put(key, value);
        return value;
    }

    public static void init() {
        File file = FileUtil.getFile(ElementOriginLib.inst(), "", "zh_cn.json");
        if (!file.exists()) {
            ElementOriginLib.inst().saveResource("zh_cn.json", false);
        }
        try {
            String s = new String(Files.readAllBytes(Paths.get(file.toURI())));
            jsonObject = new JSONObject(s);
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

}
