package com.io.yutian.elementoriginlib.util;

import org.json.JSONObject;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.URL;
import java.util.UUID;

public class MojongAPI {

    public static final String uuidURL = "https://sessionserver.mojang.com/session/minecraft/profile/";
    public static final String nameURL = "https://api.mojang.com/users/profiles/minecraft/";

    public static JSONObject getPlayerJSON(UUID uuid, String name) throws IOException {
        URL url;

        if (name != null) {
            url = new URL(nameURL + name);
        } else {
            url = new URL(uuidURL + uuid);
        }
        HttpURLConnection connection = (HttpURLConnection) url.openConnection();
        connection.setUseCaches(false);
        connection.setInstanceFollowRedirects(true);
        connection.setDoOutput(true);
        connection.setDoInput(true);
        connection.setRequestMethod("GET");

        BufferedReader bufferedReader = new BufferedReader(
                new InputStreamReader(connection.getInputStream()));
        String line;
        StringBuilder stringBuilder = new StringBuilder();
        while ((line = bufferedReader.readLine()) != null) {
            stringBuilder.append(line);
        }
        bufferedReader.close();
        if (!stringBuilder.toString().startsWith("{")) {
            return null;
        }
        return new JSONObject(stringBuilder.toString());
    }

    public static UUID getUUID(String name) {
        try {
            String uuidTemp = getPlayerJSON(null, name).getString("id");
            String uuid = "";
            for (int i = 0; i <= 31; i++) {
                uuid = uuid + uuidTemp.charAt(i);
                if (i == 7 || i == 11 || i == 15 || i == 19) {
                    uuid = uuid + "-";
                }
            }
            if (getPlayerJSON(null, name) != null) {
                return UUID.fromString(uuid);
            }
        } catch (Exception e) {
            return null;
        }
        return null;
    }

    public static String getName(UUID uuid) {
        try {
            if (getPlayerJSON(uuid, null) != null) {
                return getPlayerJSON(uuid, null).getString("name");
            }
            return null;
        } catch (Exception e) {
            return null;
        }
    }

}
