package com.io.yutian.elementoriginlib.util;

import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;

public class TimeUtil {

    private static final int HOUR_SECOND = 60 * 60;
    private static final int MINUTE_SECOND = 60;

    public static boolean inOreDay(long time1, long time2) {
        Date date = new Date(time1);
        Date date2 = new Date(time2);
        Calendar calendar = Calendar.getInstance();
        Calendar calendar2 = Calendar.getInstance();
        calendar.setTime(date);
        int y1 = calendar.get(Calendar.YEAR);
        int d1 = calendar.get(Calendar.DAY_OF_YEAR);
        calendar2.setTime(date2);

        int y2 = calendar2.get(Calendar.YEAR);
        int d2 = calendar2.get(Calendar.DAY_OF_YEAR);
        return y1 == y2 && d1 == d2;
    }

    public static boolean inOreWeek(long time1, long time2) {
        Date date = new Date(time1);
        Date date2 = new Date(time2);
        Calendar calendar = Calendar.getInstance();
        Calendar calendar2 = Calendar.getInstance();
        calendar.setTime(date);
        int y1 = calendar.get(Calendar.YEAR);
        int d1 = calendar.get(Calendar.WEEK_OF_YEAR);
        calendar2.setTime(date2);
        int y2 = calendar2.get(Calendar.YEAR);
        int d2 = calendar2.get(Calendar.WEEK_OF_YEAR);
        return y1 == y2 && d1 == d2;
    }

    public static boolean inOreMonth(long time1, long time2) {
        Date date = new Date(time1);
        Date date2 = new Date(time2);
        Calendar calendar = Calendar.getInstance();
        Calendar calendar2 = Calendar.getInstance();
        calendar.setTime(date);
        int y1 = calendar.get(Calendar.YEAR);
        int d1 = calendar.get(Calendar.MONTH);
        calendar2.setTime(date2);
        int y2 = calendar2.get(Calendar.YEAR);
        int d2 = calendar2.get(Calendar.MONTH);
        return y1 == y2 && d1 == d2;
    }

    public static String timeToString(long time) {
        SimpleDateFormat simpleDateFormat = new SimpleDateFormat("yyyy/MM/dd");
        return simpleDateFormat.format(new Date(time));
    }

    public static String getTimeStringBySecondFormat(long second) {
        if (second <= 0) {
            return "0小时0分钟0秒";
        }
        StringBuilder sb = new StringBuilder();
        long hours = second / HOUR_SECOND;
        if (hours > 0) {
            second -= hours * HOUR_SECOND;
        }
        long minutes = second / MINUTE_SECOND;
        if (minutes > 0) {
            second -= minutes * MINUTE_SECOND;
        }
        String hoursString = String.valueOf(hours);
        String minutesString = (minutes >= 10 ? (minutes + "") : ("0" + minutes));
        String secondString = (second >= 10 ? (second + "") : ("0" + second));
        return hoursString+"小时"+minutesString+"分钟"+secondString+"秒";
    }

    public static String getTimeStringBySecond(long second) {
        if (second <= 0) {
            return "00:00:00";
        }
        StringBuilder sb = new StringBuilder();
        long hours = second / HOUR_SECOND;
        if (hours > 0) {
            second -= hours * HOUR_SECOND;
        }
        long minutes = second / MINUTE_SECOND;
        if (minutes > 0) {
            second -= minutes * MINUTE_SECOND;
        }
        return (hours >= 10 ? (hours + "")
                : ("0" + hours) + ":" + (minutes >= 10 ? (minutes + "") : ("0" + minutes)) + ":"
                + (second >= 10 ? (second + "") : ("0" + second)));
    }

}